# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::StorageCache::Mgmt::V2019_11_01
  module Models
    #
    # A resource SKU.
    #
    class ResourceSku

      include MsRestAzure

      # @return [String] The type of resource the SKU applies to.
      attr_accessor :resource_type

      # @return [Array<ResourceSkuCapabilities>] A list of capabilities of this
      # SKU, such as throughput or ops/sec.
      attr_accessor :capabilities

      # @return [Array<String>] The set of locations that the SKU is available.
      # This will be supported and registered Azure Geo Regions (e.g., West US,
      # East US, Southeast Asia, etc.).
      attr_accessor :locations

      # @return [Array<ResourceSkuLocationInfo>] The set of locations that the
      # SKU is available.
      attr_accessor :location_info

      # @return [String] The name of this SKU.
      attr_accessor :name

      # @return [Array<Restriction>] The restrictions preventing this SKU from
      # being used. This is empty if there are no restrictions.
      attr_accessor :restrictions


      #
      # Mapper for ResourceSku class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ResourceSku',
          type: {
            name: 'Composite',
            class_name: 'ResourceSku',
            model_properties: {
              resource_type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'resourceType',
                type: {
                  name: 'String'
                }
              },
              capabilities: {
                client_side_validation: true,
                required: false,
                serialized_name: 'capabilities',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ResourceSkuCapabilitiesElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ResourceSkuCapabilities'
                      }
                  }
                }
              },
              locations: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'locations',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              location_info: {
                client_side_validation: true,
                required: false,
                serialized_name: 'locationInfo',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ResourceSkuLocationInfoElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ResourceSkuLocationInfo'
                      }
                  }
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              restrictions: {
                client_side_validation: true,
                required: false,
                serialized_name: 'restrictions',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'RestrictionElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'Restriction'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
